#!/usr/bin/python
#rozbiehanie programu
import pygame
import os
import platform
if platform.system() == 'Windows':
    os.environ['SDL_VIDEODRIVER'] = 'windib'
pygame.init()
from pygame import *
from random import *
from time import *
import pickle
init()
#definicia farieb
black    = (   0,   0,   0)
white    = ( 255, 255, 255)
green    = (   0, 255,   0)
red      = ( 255,   0,   0)
blue     = (   0,   0, 255)
violet   = ( 128,   0, 127)
yellow   = ( 255, 255,   0)
travnik  = (   0, 214,   0)
hneda    = ( 166, 124,  35)
voda     = (  20, 154, 181)

velkost_obrazovky = (1366,768)#(0,0)
realne_o = display.set_mode(velkost_obrazovky,FULLSCREEN)
o = realne_o#Surface((1366,768))

SCREEN_W, SCREEN_H = o.get_size()

#Čo znamená SUOMIS?
display.set_caption("SUOMIS")
o.fill(black)
display.update()
cyklus = True
hodiny = pygame.time.Clock()

#obrazky
#raketky
rkt = image.load("raketka.gif").convert()
rkt_shielded = image.load("raketka-shielded.gif").convert()
#strely
possible_missile_image = [image.load("strela.gif").convert(),image.load("AP-strela.gif").convert(),image.load("MSM-strela.gif").convert()]

bmb = image.load("bomba.gif").convert()
vybch = image.load("vybuch.gif").convert()
#nepriatelov
possible_enemy_image = [image.load("n_1.gif").convert_alpha(),image.load("n_2.gif").convert_alpha(),image.load("enemy-turret.gif").convert_alpha(),
                        image.load("enemy-pattern-drop.gif").convert_alpha(),image.load("enemy-bumerang-drop.gif").convert_alpha()]
nepr = [image.load("n_1.gif").convert_alpha(),image.load("n_2.gif").convert_alpha(),image.load("n_3.gif").convert_alpha()]
obrazok_nepriatel_neviditelny = [image.load("n_1.gif").convert(),image.load("n_2.gif").convert(),image.load("n_3.gif").convert()]
for a in obrazok_nepriatel_neviditelny:
  a.set_alpha(10)
#pozicia mysy
poz = 0
#font
fonty = font.SysFont("Fixedsys Regular", 60)
fontyy = font.SysFont("Fixedsys Regular", 300)
fontyyy = font.SysFont("Fixedsys Regular", 100)
#skore
skore = 0
#bonus (moze byt "Triple")
bonus = ""
cas_b = 0

#list of possible "bomb" image
possible_bomb_image = [bmb,image.load("beam-bomb.gif").convert(),image.load("pattern-bomb.gif").convert(),image.load("bumerang-bomb.gif").convert()
                       ,image.load("bumerang-bomb2.gif").convert()]

#BOSS-obrazky
obrazok_boss = image.load("boss-core.gif").convert()


#odstranenie odpadu
import gc
gc.enable()
#copy
import copy

#debug-mode
debugmode = False

class raketa():
    x = SCREEN_W / 2
    y = SCREEN_H - 100
    stvorec = Rect(SCREEN_W / 2,SCREEN_H + 20,40,40)
    shield_recharge = 0
    shield = 3
    max_shield = 3
    #def __init__(self):
      #self.stvorec = Rect(self.x,self.y,60,60)
    def nakresli(self):
        if self.shield != self.max_shield:
            self.shield_recharge += 1
            if self.shield_recharge == 100:
                self.shield += 1
                self.shield_recharge = 0
                
        if debugmode == True:
            draw.rect(o,blue,self.stvorec)
        
        if self.shield > 0:
            o.blit(rkt_shielded,[self.stvorec.x-10,self.stvorec.y - 8])
        else:
            o.blit(rkt,[self.stvorec.x-10,self.stvorec.y - 8])
    def pohyb(self):
        global poz
        poz = mouse.get_pos()
        if poz[0] > self.stvorec.centerx and not self.stvorec.x >= SCREEN_W-250:
            self.stvorec.x += 10
        if poz[0] < self.stvorec.centerx and not self.stvorec.x < 0:
            self.stvorec.x -= 10
        if poz[1] > self.stvorec.centery and not self.stvorec.y >= SCREEN_H-10:
            self.stvorec.y += 10
        if poz[1] < self.stvorec.centery:
            self.stvorec.y -= 10

class strela():
    x = int
    y = int
    speed_x = 0
    speed_y = -20
    vylepsenia = str
    stvorec = 1
    image_position = 0
    def __init__(self,image_positiona = 0,vylepsenia = "",speed_x = 0,speed_y = -20):
        self.image_size = possible_missile_image[image_positiona].get_size()
        self.image_position = image_positiona

        self.x = raketka.stvorec.centerx - 10
        self.y = raketka.stvorec.y - 30
        self.stvorec = Rect(self.x-self.image_size[0]/4,self.y,self.image_size[0],self.image_size[1])
        self.vylepsenia = vylepsenia
        self.speed_x = speed_x
        self.speed_y = speed_y
    def nakresli(self):
        if debugmode == True:
            draw.rect(o,green,self.stvorec)
        o.blit(possible_missile_image[self.image_position],[self.stvorec.x,self.stvorec.y])
    def pohyb(self):
        self.stvorec.x += self.speed_x
        self.stvorec.y += self.speed_y
        if self.vylepsenia == "MSM":
            self.speed_y = randint(-5,-1)
            if randint(1,3) == 3:
                if randint(1,2) == 1 and not self.stvorec.x <= 10:
                    self.speed_x = randint(-10,-5)
                elif not self.stvorec.x >= SCREEN_W-250:
                    self.speed_x = randint(5,10)
        if self.stvorec.x >= SCREEN_W-250:
            self.stvorec.x -= 10
            self.speed_x = self.speed_x * -1
        if self.stvorec.x <= 10:
            self.stvorec.x += 10
            self.speed_x = self.speed_x * -1

class nepriatel():
    x = int
    y = int
    zivoty = int
    smer = 1
    pocit = 0
    nabit = 9
    vylepsenia = []
    charge = 0
    active_stealth = False
    #pre detekciu kolizie
    stvorec = 0
    #obrazok-typ-nepriatela?!
    image_position = 0
    image_size = []
    #boss_part
    boss_part = False

    #firing-speed
    firing_speed = 1
    #RFLB
    slot = 0
    def __init__(self,boss_part = False,x = 0,y = 0,image_position = 0, zivoty = 0):
        self.x = randint(0,SCREEN_W-250)
        self.y = randint(0,10) * -1 - 10
        self.image_position = randint(1,13)-1
        if self.image_position == 12 and randint(1,3) != 3:
             self.image_position = randint(1,4)-1
        if self.image_position < 3:
            self.image_position = 0
        elif self.image_position < 7:
            self.image_position = 1
        elif self.image_position < 10:
            self.image_position = 2
        elif self.image_position <= 11:
            self.image_position = 3
        self.zivoty = self.image_position * 3 + 1#randint(1,3)
        if self.image_position == 12:
            self.image_position = 4
        self.vylepsenia = []

        #Being part of BOSS
        if boss_part == True:
            self.boss_part = True
            self.image_position = image_position
            if self.image_position == 4 and randint(1,2) != 2:
               self.image_position = randint(1,3) 
            self.zivoty = zivoty
            self.x = x
            self.y = y
        
        if self.image_position == 0:
            self.vylepsenia.append("samovrah")
            self.vylepsenia.append("neviditelnost")
        if self.image_position == 1:
            self.vylepsenia.append("turret")
        if self.image_position == 2:
            self.vylepsenia.append("RFLB")
            self.firing_speed = 5
        if self.image_position == 3:
            self.vylepsenia.append("pattern-drop")
        if self.image_position == 4:
            self.vylepsenia.append("bumerang-drop")

        self.image_size = possible_enemy_image[self.image_position].get_size()    
        self.stvorec = Rect(self.x,self.y,self.image_size[0],self.image_size[1])
    def nakresli(self):
        if debugmode == True:
            draw.rect(o,red,self.stvorec)
        if not self.active_stealth:
            if self.image_position == 0:
                o.blit(nepr[0],[self.stvorec.x,self.stvorec.y])
            else:
                o.blit(possible_enemy_image[self.image_position],[self.stvorec.x,self.stvorec.y])
      #neviditelnost
        if "neviditelnost" in self.vylepsenia:
            if self.charge > 1 and self.active_stealth == True:
                self.charge -= 2
                o.blit(obrazok_nepriatel_neviditelny[0],[self.stvorec.x,self.stvorec.y])
            #if self.zivoty == 2:
                #o.blit(obrazok_nepriatel_neviditelny[1],[self.stvorec.x-5,self.stvorec.y-5])
            #if self.zivoty >= 3:
                #o.blit(obrazok_nepriatel_neviditelny[2],[self.stvorec.x-5,self.stvorec.y-5])
            else:
                self.active_stealth = False
                self.charge += 101
            if self.charge > 100:
                self.active_stealth = True
    
    def pohyb(self):
        self.pocit += 1
        if self.pocit == 20:
            self.smer = randint(1,4)
            self.pocit = 0
        if self.smer == 1:
            self.stvorec.y += 2
        if self.smer == 2 and not self.stvorec.x <= 5:
            self.stvorec.x -= 2
        if self.smer == 3 and not self.stvorec.y <= 30:
            self.stvorec.y -= 2
        if self.smer == 4 and not self.stvorec.centerx >= SCREEN_W-270:
            self.stvorec.x += 2
        if self.smer == 4 and self.stvorec.centerx >= SCREEN_W-270:
            self.pocit = 19
        if self.smer == 2 and self.stvorec.x <= 10:
            self.pocit = 19
        if "samovrah" in self.vylepsenia:
            if raketka.stvorec.x + 10 > self.stvorec.x and not self.stvorec.x >= SCREEN_W-250:
                self.stvorec.x += 4
            if raketka.stvorec.x + 10 < self.stvorec.x:
                self.stvorec.x -= 4
            if raketka.stvorec.y + 10 > self.stvorec.y:
                self.stvorec.y += 4
            if raketka.stvorec.y < self.stvorec.y:
                self.stvorec.y -= 4
            
    def zhod(self):
        self.nabit += self.firing_speed
        if self.nabit >= 150 and self.zivoty > 1:
            self.nabit = 0
            if "turret" in self.vylepsenia:
                vzdialenost = [raketka.stvorec.centerx - self.stvorec.centerx,raketka.stvorec.centery - self.stvorec.centery]
                while vzdialenost[0] > 15 or vzdialenost[0] < -15:
                    vzdialenost[0] = vzdialenost[0]/10
                while vzdialenost[1] > 15 or vzdialenost[1] < -15:
                    vzdialenost[1] = vzdialenost[1]/10
                bomby.append(bomba(self.stvorec.centerx,self.stvorec.centery,"",vzdialenost[0],vzdialenost[1],0))
            elif "pattern-drop" in self.vylepsenia:
                bomby.append(bomba(self.stvorec.centerx,self.stvorec.centery,"pattern",10,10,2))
            elif "bumerang-drop" in self.vylepsenia:
                bomby.append(bomba(self.stvorec.centerx,self.stvorec.centery,"bumerang",10,10,3))
            else:
                bomby.append(bomba(self.stvorec.x + 10 + self.slot * 5,self.stvorec.centery,"",1,10,1))
                bomby.append(bomba(self.stvorec.centerx + self.slot * 5,self.stvorec.centery,"",1,10,1))
                self.slot +=1
                if self.slot == 4:
                    self.slot = 0

class bomba():
    stvorec = 0
    speed_x = 0
    speed_y = 0
    special_behaviour = ""
    image_position = 0

    #pattern-bombs
    smer = 1
    pocit = 0

    #Bumerang
    phase = 0
    vzdialenost = []
    phases = 1

    #image
    image_size = []
    
    def __init__(self,x,y,behaviour,speed_x,speed_y,image_positiona):
        self.image_size = possible_bomb_image[image_positiona].get_size()
        self.image_position = image_positiona
        
        self.stvorec = Rect(x,y,self.image_size[0],self.image_size[1])
        self.special_behaviour = behaviour
        self.speed_x = speed_x
        self.speed_y = speed_y
        
    def pohyb(self):
        if self.special_behaviour == "":
            self.stvorec.x += self.speed_x
            self.stvorec.y += self.speed_y
            if self.stvorec.x >= SCREEN_W-250:
                self.speed_x = self.speed_x * -1
            if self.stvorec.x <= 10:
                self.speed_x = self.speed_x * -1
        #pattern-bombs
        if self.special_behaviour == "pattern":
            self.pocit += 1
            if self.pocit == 20:
                self.smer = randint(1,3)
                #if self.smer == 1:
                    #self.smer = randint(1,3)
                self.pocit = 0
            if self.smer == 1:
                self.stvorec.y += self.speed_y
            if self.smer == 2 and not self.stvorec.x <= 5:
                self.stvorec.x -= self.speed_x
            if self.smer == 3 and not self.stvorec.x >= SCREEN_W-250:
                self.stvorec.x += self.speed_x
            if self.smer == 3 and self.stvorec.x >= SCREEN_W-250:
                self.pocit = 19
            if self.smer == 2 and self.stvorec.x <= 10:
                self.pocit = 19
        #Bumerang
        if self.special_behaviour == "bumerang":
            if self.phase == 0:
                self.stvorec.y += self.speed_y
                if SCREEN_H - 40 <= self.stvorec.y and not self.phases == 4:
                    self.vzdialenost = [raketka.stvorec.centerx - self.stvorec.centerx,raketka.stvorec.centery - self.stvorec.centery]
                    while self.vzdialenost[0] > 25 or self.vzdialenost[0] < -25:
                        self.vzdialenost[0] = self.vzdialenost[0]/10
                    while self.vzdialenost[1] > 25 or self.vzdialenost[1] < -25:
                        self.vzdialenost[1] = self.vzdialenost[1]/10
                    self.speed_x = self.vzdialenost[0]
                    self.speed_y = self.vzdialenost[1]
                    self.phase = 1
                    self.image_position += 1
                    self.phases +=1
            if self.phase == 1:
                self.stvorec.x += self.speed_x
                self.stvorec.y += self.speed_y
                if self.stvorec.x >= SCREEN_W-250:
                    self.speed_x = self.speed_x * -1
                if self.stvorec.x <= 10:
                    self.speed_x = self.speed_x * -1
                if 20 >= self.stvorec.y:
                    self.image_position -= 1
                    self.phase = 0
                    self.phases +=1
                    self.speed_y = 10

                    
    def nakresli(self):
        if debugmode == True:
            draw.rect(o,yellow,self.stvorec)
        o.blit(possible_bomb_image[self.image_position],(self.stvorec.x,self.stvorec.y))

#BOSS?!
class Boss():
    stvorec = 0
    zivoty = 200
    linked = []
    #pohyb
    smer = 1
    pocit = 0
    #obrazok
    img_size = []

    def __init__(self):
        self.img_size = obrazok_boss.get_size()
        self.stvorec = Rect(SCREEN_W/2-self.img_size[0]/2-100,SCREEN_H/4-self.img_size[1]/2,self.img_size[0],self.img_size[1])
    def nakresli(self):
        o.blit(obrazok_boss,[self.stvorec.x,self.stvorec.y])
        self.pocit += 1
        if self.pocit == 20:
            self.smer = randint(2,3)
            self.pocit = 0
        if self.smer == 2 and not self.stvorec.x <= 405:
            self.stvorec.x -= 10
            for i in self.linked:
                i.stvorec.x -= 10
        if self.smer == 3 and not self.stvorec.x >= SCREEN_W-700:
            self.stvorec.x += 10
            for i in self.linked:
                i.stvorec.x += 10
        if self.smer == 3 and self.stvorec.x >= SCREEN_W-700:
            self.pocit = 19
        if self.smer == 2 and self.stvorec.x <= 10:
            self.pocit = 19
    def spawnuj(self):
        self.linked.append(nepriatel(True,(randint(-20,20)*20)+self.stvorec.centerx,(randint(-20,20)*10)+self.stvorec.centery,randint(1,4),randint(100,200)))

        
        

raketka = raketa()
strely = []
nepriat = []
bomby = []

#pomocne premenne
nabite = 3
spawn = 0
spawn_rate = 30
ciel = 200
maxim = 20

#hudba
try:
    mixer.music.load("hudba.mp3")
    mixer.music.play(-1)
except pygame.error:
    print("Súbor hudba.mp3 nenájdený")
    print("Hudba nebude hrať")

#Main Menu
def MainMenu():
    text = fontyy.render("SUOMIS",True,red)
    texta = fonty.render("START GAME",True,green)
    textaa = fonty.render("QUIT",True,red)
    cyklus = True
    texta_size = texta.get_size()
    textaa_size = textaa.get_size()
    while cyklus == True:
        poz = mouse.get_pos()
        for udalost in event.get():
            if udalost.type == QUIT:
                cyklus = False
            if udalost.type == MOUSEBUTTONDOWN: 
                if poz[0] > SCREEN_W/4 and poz[0] < SCREEN_W/4 + texta_size[0] and poz[1] > SCREEN_H/2 and poz[1] < SCREEN_H/2 + texta_size[1]:
                    return True
                if poz[0] > SCREEN_W/4 and poz[0] < SCREEN_W/4 + textaa_size[0] and poz[1] > SCREEN_H/2 + 100 and poz[1] < SCREEN_H/2 + 100 + textaa_size[1]:
                    return False
        text = fontyy.render("SUOMIS",True,[randint(1,255),randint(1,255),randint(1,255)])
        o.blit(text,[SCREEN_W/8,SCREEN_H/8])
        o.blit(texta,[SCREEN_W/4,SCREEN_H/2])
        o.blit(textaa,[SCREEN_W/4,SCREEN_H/2 + 100])
        display.flip()

#Pause
def Pause():
    mixer.music.pause()
    text = fontyyy.render("GAME PAUSED",True,red)
    texta = fonty.render("Continue",True,yellow)
    textaa = fonty.render("Quit",True,yellow)
    cyklus = True
    texta_size = texta.get_size()
    textaa_size = textaa.get_size()
    while cyklus == True:
        poz = mouse.get_pos()
        for udalost in event.get():
            if udalost.type == QUIT:
                cyklus = False
            if udalost.type == MOUSEBUTTONDOWN: 
                if poz[0] > SCREEN_W/4 and poz[0] < SCREEN_W/4 + texta_size[0] and poz[1] > SCREEN_H/2 and poz[1] < SCREEN_H/2 + texta_size[1]:
                    mixer.music.unpause()
                    return True
                if poz[0] > SCREEN_W/4 and poz[0] < SCREEN_W/4 + textaa_size[0] and poz[1] > SCREEN_H/2 + 100 and poz[1] < SCREEN_H/2 + 100 + textaa_size[1]:
                    return False
        #text = fontyy.render("Game paused",True,[randint(1,255),randint(1,255),randint(1,255)])
        o.blit(text,[SCREEN_W/4,SCREEN_H/8])
        o.blit(texta,[SCREEN_W/4,SCREEN_H/2])
        o.blit(textaa,[SCREEN_W/4,SCREEN_H/2 + 100])
        display.flip()

#GAME OVER
def GameOver():
    display.flip()
    display.flip()
    display.flip()
    mixer.music.pause()
    text = fontyyy.render("GAME OVER",True,red)
    texta = fonty.render("Your score:",True,yellow)
    textaa = fonty.render("Quit",True,yellow)
    textaaa = fonty.render(str(skore),True,blue)
    cyklus = True
    texta_size = texta.get_size()
    textaa_size = textaa.get_size()
    while cyklus == True:
        poz = mouse.get_pos()
        for udalost in event.get():
            if udalost.type == QUIT:
                cyklus = False
            if udalost.type == MOUSEBUTTONDOWN: 
                if poz[0] > SCREEN_W/4 and poz[0] < SCREEN_W/4 + textaa_size[0] and poz[1] > SCREEN_H/2 + 100 and poz[1] < SCREEN_H/2 + 100 + textaa_size[1]:
                    return False
        #text = fontyy.render("Game paused",True,[randint(1,255),randint(1,255),randint(1,255)])
        o.blit(text,[SCREEN_W/4,SCREEN_H/8])
        o.blit(texta,[SCREEN_W/4,SCREEN_H/2])
        o.blit(textaaa,[SCREEN_W/2,SCREEN_H/2])
        o.blit(textaa,[SCREEN_W/4,SCREEN_H/2 + 100])
        display.flip()

#GAME OVER
def Victory():
    mixer.music.pause()
    text = fontyyy.render("YOU WON!!!",True,red)
    texta = fonty.render("Your score:",True,yellow)
    textaa = fonty.render("Quit",True,yellow)
    textaaa = fonty.render(str(skore),True,blue)
    cyklus = True
    texta_size = texta.get_size()
    textaa_size = textaa.get_size()
    while cyklus == True:
        poz = mouse.get_pos()
        for udalost in event.get():
            if udalost.type == QUIT:
                cyklus = False
            if udalost.type == MOUSEBUTTONDOWN: 
                if poz[0] > SCREEN_W/4 and poz[0] < SCREEN_W/4 + textaa_size[0] and poz[1] > SCREEN_H/2 + 100 and poz[1] < SCREEN_H/2 + 100 + textaa_size[1]:
                    return False
        #text = fontyy.render("Game paused",True,[randint(1,255),randint(1,255),randint(1,255)])
        o.blit(text,[SCREEN_W/4,SCREEN_H/8])
        o.blit(texta,[SCREEN_W/4,SCREEN_H/2])
        o.blit(textaaa,[SCREEN_W/2,SCREEN_H/2])
        o.blit(textaa,[SCREEN_W/4,SCREEN_H/2 + 100])
        display.flip()


cyklus = MainMenu()

boss_fight = False

def vystrel():
    strely.append(strela())

#Missiles
AP_recharge = 0
MSM_recharge = 0
chosen_one = 0 # :D

#BOSS-parts
core = Boss()
for i in range(30):
    core.spawnuj()

while cyklus == True:
    for udalost in event.get():
        if udalost.type == QUIT:
            cyklus = False
        if udalost.type == MOUSEBUTTONDOWN:
            if udalost.button == 2:
                cyklus = Pause()
            if udalost.button == 4:
                chosen_one = 0
            if udalost.button == 5:
                chosen_one = 1
            #Missile launch
            if udalost.button == 3:
                if chosen_one == 0 and AP_recharge >= 100.0:
                    AP_recharge = 0
                    strely.append(strela(1,"AP",0,-5))
                if chosen_one == 1 and MSM_recharge >= 100.0:
                    MSM_recharge = 0
                    for i in range(60):
                        strely.append(strela(2,"MSM",0,randint(-5,-1)))
                    

    nabite += 1
    if mouse.get_pressed()[0] == 1 and (nabite > 3 or bonus == "Triple"):
        vystrel()
        nabite = -2
        if mouse.get_pressed()[0] == 1:
            vystrel()
            vystrel()
            strely[-1].speed_x += 10
            strely[-3].speed_x -= 10
            
    raketka.pohyb()
    
    o.fill(black)
    draw.rect(o,green,[SCREEN_W-200,0,200,SCREEN_H])
    raketka.nakresli()
    if len(strely) > 0:
        for za in range(len(strely)):
            try:
                strely[za-1].nakresli()
                strely[za-1].pohyb()
            except IndexError:
                pass

    if len(strely) > 0:
        for z in range(len(strely)):
            try:
                if strely[z-1].stvorec.y < -200:
                    strely.pop(z-1)
            except IndexError:
                pass
            
    #nepriatelia
    spawn += 1
    if spawn > spawn_rate:
      for i in range(10):
        if not len(nepriat) >= maxim:
          nepriat.append(nepriatel())
          spawn = 0
    if len(nepriat) > 0:
        for za in range(len(nepriat)):
            nepriat[za-1].nakresli()
            nepriat[za-1].pohyb()
            nepriat[za-1].zhod()
        try:
            for za in nepriat:
                if raketka.stvorec.colliderect(za.stvorec):
                    if not raketka.shield > 0:
                        cyklus = False
                        o.blit(vybch,[raketka.stvorec.centerx - 40,raketka.stvorec.centery-40])
                        GameOver()
                    else:
                        raketka.shield -= 1
                        o.blit(vybch,[za.stvorec.x-40,za.stvorec.y-40])
                        za.zivoty = 0
                        
        except IndexError:
            pass
    try:        
        for g in range(len(strely)):
            for h in range(len(nepriat)):
                if nepriat[h-1].stvorec.colliderect(strely[g-1].stvorec):
                    if not strely[g-1].vylepsenia == "AP":
                        strely[g-1].stvorec.y = -200
                        if not strely[g-1].vylepsenia == "MSM":
                            nepriat[h-1].zivoty -= 1
                    if strely[g-1].vylepsenia == "AP":
                        nepriat[h-1].zivoty -= 5
                        skore += 3*4
                    skore += 3

                    if strely[g-1].vylepsenia == "MSM":
                        nepriat[h-1].zivoty -= 1.0/2.0
                        skore -= 1
                    if nepriat[h-1].zivoty < 1:
                        o.blit(vybch,[nepriat[h-1].stvorec.centerx,nepriat[h-1].stvorec.centery])
                        nepriat[h-1] = "deleted"
                if nepriat[h-1].zivoty <= 0:
                    nepriat[h-1] = "deleted"
    except IndexError:
        pass
    except AttributeError:
        pass
    try:
        for i in range(100):
            nepriat.remove("deleted")
    except ValueError:
        pass

    #nepriatelske_projektily
    for z in bomby:
        z.nakresli()
        z.pohyb()
        try:
            if raketka.stvorec.colliderect(z.stvorec):
                if not raketka.shield > 0:
                    cyklus = False
                    o.blit(vybch,[raketka.stvorec.centerx - 40,raketka.stvorec.centery-40])
                    GameOver()
                else:
                    raketka.shield -= 1
                    z.stvorec.x += 10000
        except IndexError:
            pass


    #BOSS-FIGHT
    if boss_fight == True:
        spawn -= 10000
        for i in core.linked:
            draw.line(o,[120,50,120],[core.stvorec.centerx,core.stvorec.centery],[i.stvorec.centerx,i.stvorec.centery],3)
        core.nakresli()
        for i in core.linked:
            i.nakresli()
            i.zhod()
            if raketka.stvorec.colliderect(i.stvorec):
                cyklus = False
                o.blit(vybch,[raketka.stvorec.centerx - 40,raketka.stvorec.centery-40])
                GameOver()
        #detekcia zasahov
        for g in range(len(strely)):
            for h in range(len(core.linked)):
                try:
                    if core.linked[h-1].stvorec.colliderect(strely[g-1].stvorec):
                        if not strely[g-1].vylepsenia == "AP":
                            strely[g-1].stvorec.y = -200
                            if not strely[g-1].vylepsenia == "MSM":
                                core.linked[h-1].zivoty -= 1
                        if strely[g-1].vylepsenia == "AP":
                            core.linked[h-1].zivoty -= 5
                            skore += 3*4
                        skore += 3

                        if strely[g-1].vylepsenia == "MSM":
                            core.linked[h-1].zivoty -= 1.0/2.0
                            skore -= 1
                        if core.linked[h-1].zivoty < 1:
                            o.blit(vybch,[core.linked[h-1].stvorec.centerx,core.linked[h-1].stvorec.centery])
                            core.linked[h-1] = "deleted"
                except AttributeError:
                    pass
                #if core.linked[h-1].zivoty <= 0:
                    #core.linked[h-1] = "deleted"
                    
        #odpracme mrtvoly
        for iz in range(10):
            try:
                for i in range(100):
                    core.linked.remove("deleted")
            except ValueError:
                pass
        #koniec BOSSA :(
        if core.linked == []:
            o.fill(black)
            display.flip()
            cyklus = Victory()

        

    
    #ukazatele
    text = fonty.render("Score",True,red)
    texta = fonty.render(str(skore),True,blue)
    textaa = fonty.render("Bonus",True,red)
    textaaa = fonty.render(bonus,True,blue)
    textaaaa = fonty.render(str(cas_b),True,yellow)
    o.blit(text,[SCREEN_W-180,0])
    o.blit(texta,[SCREEN_W-180,70])
    o.blit(textaa,[SCREEN_W-180,300])
    o.blit(textaaa,[SCREEN_W-180,340])

    #Shields
    text = fonty.render("Shield",True,red)
    o.blit(text,[SCREEN_W-180,120])
    if not raketka.max_shield == raketka.shield:
        draw.rect(o,[255-raketka.shield_recharge*2.55,255-raketka.shield_recharge*2.55,raketka.shield_recharge*2.55],(SCREEN_W-180,160,raketka.shield_recharge+5,20))
    for i in range(raketka.shield):
        draw.rect(o,blue,(SCREEN_W-180,210-i*25+25,105,20))

    #Missiles
    text = fonty.render("Missiles",True,red)
    o.blit(text,[SCREEN_W-180,SCREEN_H-320])
    text = fonty.render("AP",True,yellow)
    o.blit(text,[SCREEN_W-180,SCREEN_H-240])
    text = fonty.render("MSM",True,yellow)
    o.blit(text,[SCREEN_W-180,SCREEN_H-120])
    if not AP_recharge >= 101.0:
        draw.rect(o,[randint(1,10)*2.55,255-randint(1,10)*2.55,255-randint(1,10)*2.55],(SCREEN_W-180,SCREEN_H-200,AP_recharge+5,40))
    else:
        draw.rect(o,[255-randint(1,50)*2.55,255-randint(1,50)*2.55,randint(1,50)*2.55],(SCREEN_W-180,SCREEN_H-200,AP_recharge+5,40))
    if not MSM_recharge >= 101.0:
        draw.rect(o,[randint(1,10)*2.55,255-randint(1,10)*2.55,255-randint(1,10)*2.55],(SCREEN_W-180,SCREEN_H-80,MSM_recharge+5,40))
    else:
        draw.rect(o,[255-randint(1,50)*2.55,255-randint(1,50)*2.55,randint(1,50)*2.55],(SCREEN_W-180,SCREEN_H-80,MSM_recharge+5,40))

    if chosen_one == 0:
        draw.rect(o,[0,0,160-randint(1,5)*10],[SCREEN_W-190,SCREEN_H-250,140,120],4)
    if chosen_one == 1:
        draw.rect(o,[0,0,160-randint(1,5)*10],[SCREEN_W-190,SCREEN_H-150,140,120],4)
    

    if not AP_recharge >= 101.0:
        AP_recharge += 1
    if not MSM_recharge >= 101.0:
        MSM_recharge += 0.5
    
    if not bonus == "":
        o.blit(textaaaa,[SCREEN_W-180,390])

    if cas_b > 0:
        cas_b -= 1
    if cas_b == 0:
        bonus = ""

    if skore > ciel:
        bonus = "Triple"
        spawn_rate -= 0.1
        cas_b = 200
        ciel += 2000

    #test-zvysovanie narocnosti
    if skore % 1000 == 1:
        skore += 1
        maxim += 5
    if skore > 8000 and not boss_fight == True:
        boss_fight = True
        nepriat = []
        spawn_rate = 100000
        strely = []
        bomby = []
        text = fontyyy.render("BOSS INCOMING",True,red)
        for i in range(10):
            o.fill(black)
            if i % 2 == 0:
                text = fontyyy.render("BOSS INCOMING",True,red)
            else:
                text = fontyyy.render("BOSS INCOMING",True,black)
            o.blit(text,[SCREEN_W/4,SCREEN_H/4])
            display.flip()
            sleep(0.2)

    #realne_o.fill(black)
    #transform.scale(o,(SCREEN_W,SCREEN_H),realne_o)
    
    display.flip()
    hodiny.tick(20)

try:
    with open("skore.pickle","rb") as subor:
        skore += pickle.load(subor)
except:
    pass

with open("skore.pickle","wb") as subor:
        pickle.dump(skore,subor)

quit()
